// ***************
// *** CONSOLE ***
// ***************

// this pair helps us to get rid of 'last char' SLang-related problem
// (it will affect only SLang-based console)
// There could be 4 basic combination for those:
// (0,0) - you've been warned, last char of the last row will never be seen
// (0,1) - console will be 1 row shorter, thus eliminating the problem
// (0,1) - console will be 1 column smaller, thus eliminating the problem
// (1,1) - pretty excessive, but if you like to always doublecheck - this baby works both ways ;)
#define CON_COL_FIX 0
#define CON_ROW_FIX 1

// compiles in SLang console input/output translation tables and forces default translation modes,
// allowing runtime switching via setting RTN_CON_XLATE_IN/OUT environment variable to one of:
// 0 - direct mapping
// 1 - 866 to KOI8 mapping
// 2 - KOI8 to 866 mapping
// 3 - 866 to non-cyr mapping
// 4 - alternative 866 to non-cyr mapping
#define CON_XLATE_IN  2
#define CON_XLATE_OUT 1

// compiles in X11Console input/output translation tables and forces default translation modes,
// allowing runtime switching via setting RTN_X11CON_XLATE_IN/OUT environment variable to one of:
// 0 - direct mapping
// 1 - 866 to KOI8 mapping
// 2 - KOI8 to 866 mapping
// 3 - 866 to non-cyr mapping
// 4 - alternative 866 to non-cyr mapping
#define X11CON_XLATE_IN  2
#define X11CON_XLATE_OUT 0

// defines default X11Console size
// could be overriden at runtime by setting RTN_X11CON_SIZE environment variable to WIDTHxHEIGHT
#define X11CON_WIDTH  90
#define X11CON_HEIGHT 30

// defines default X11Console font
// could be overriden at runtime by RTN_X11CON_FONT environment variable
#define X11CON_FONT "vga"
