//
// RTN console stuff - boxes
// Copyright (c) 1996-8 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "console.h"
#include <string.h>

#include "constuff.h"
#include "condraw.h"

#define askBorder 0x0c
#define askField  0x07
#define askTitle  0x0e

char askString(char*title,int x,int y,char*data,int len,int maxdata)
{
 unsigned char subact=0xff,shoulddraw=1;
 int tx,curpos=0,fake1st=0,datasize=strlen(data),key=strlen(title);
 
 if(key<len) key=len;
 c_fillc(LTCOR,1,x,y);
 c_fillc(RTCOR,1,x+key+1,y);
 c_fillc(LBCOR,1,x,y+2);
 c_fillc(RBCOR,1,x+key+1,y+2);
 c_fillc(VLINE,1,x,y+1);
 c_fillc(VLINE,1,x+key+1,y+1);
 c_fillc(HLINE,key,x+1,y);
 c_fillc(HLINE,key,x+1,y+2);
 c_puts(title,x+1,y);
 for(tx=0;tx<3;tx++) c_filla(askBorder,key+2,x,y+tx);
 c_filla(askTitle,strlen(title),x+1,y);
 c_fillc(' ',key,x+1,y+1);
 c_filla(askField,len,x+1,y+1);
 c_showcur();
 strcat(data," ");

 while(subact==0xff)
 {
  c_movecur(x+1+curpos-fake1st,y+1);
  if(shoulddraw)
  {
   c_putc(data+fake1st,((tx=1+datasize-fake1st)>len)?len:tx,x+1,y+1);
   shoulddraw=0;
  } 
  key=c_getkey();
  switch(key)
  {
   case _KBD_ENTER :subact=1;break;
   case _KBD_ESC   :subact=0;break;
   case _KBD_LEFT  :if(curpos) {curpos--;if(fake1st>curpos) {fake1st--;shoulddraw=1;}} break;
   case _KBD_RIGHT :if(curpos<datasize) {curpos++;if(fake1st+len<1+curpos) {fake1st++;shoulddraw=1;}} break;
   case _KBD_HOME  :if(curpos) {curpos=0;if(fake1st) {fake1st=0;shoulddraw=1;}} break;
   case _KBD_END   :if(curpos<datasize) {curpos=datasize;if(fake1st+len<1+datasize) {fake1st=1+datasize-len;shoulddraw=1;}} break;
   case _KBD_DEL   :if(curpos<datasize) {datasize--;strcpy(data+curpos,data+curpos+1);shoulddraw=1;} break;
   case _KBD_BS    :if(curpos) {datasize--;strcpy(data+curpos-1,data+curpos);curpos--;shoulddraw=1;if(fake1st>curpos) fake1st--;} break;
   default         :if(datasize<1+maxdata&&key<0x0100&&key!=_KBD_TAB) {for(tx=datasize+1;tx>=curpos;tx--) data[tx+1]=data[tx];data[curpos]=key;shoulddraw=1;datasize++;if(fake1st+len>1+curpos) curpos++;} break;
  }
 }
 c_hidecur();
 data[datasize]=0;
 return subact;
}

void infoBox(char*title,int x,int y,char*data)
{
 int tx,width,len=strlen(data),key=strlen(title);

 width=len>key?len:key;
 c_fillc(LTCOR,1,x,y);
 c_fillc(RTCOR,1,x+width+1,y);
 c_fillc(LBCOR,1,x,y+2);
 c_fillc(RBCOR,1,x+width+1,y+2);
 c_fillc(VLINE,1,x,y+1);
 c_fillc(VLINE,1,x+width+1,y+1);
 c_fillc(HLINE,width,x+1,y);
 c_fillc(HLINE,width,x+1,y+2);
 c_puts(title,x+1+(width-key)/2,y);
 for(tx=0;tx<3;tx++) c_filla(askBorder,width+2,x,y+tx);
 c_filla(askTitle,key,x+1+(width-key)/2,y);
 c_fillc(' ',width,x+1,y+1);
 c_filla(askField,len,x+1+(width-len)/2,y+1);
 c_puts(data,x+1+(width-len)/2,y+1);
 c_getkey();
}
