//
// RTN console implementation
// Copyright (c) 1996-9 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __RTN_CONSOLE_H
#define __RTN_CONSOLE_H

void c_init(char*title="Resolution and Hyperspace");
void c_done(void);
void c_showcur(void);
void c_hidecur(void);
void c_movecur(int,int);
void c_putc(const char*,short int,short int,short int);
void c_puta(const char*,short int,short int,short int);
void c_fillc(const char,short int,short int,short int);
void c_filla(const char,short int,short int,short int);
void c_writeca(const char*,const char,short int,short int,short int);
void c_scrollca(char,short int,short int,short int,short int);
void c_pushkey(short int);
void c_settitle(char*);
short int c_getkey(void);

extern unsigned short int cMaxX, cMaxY;

// wrapper
#define c_puts(a,b,c) c_putc(a,strlen(a),b,c)

// scroll directions
#define SCROLL_UP	0x00
#define SCROLL_DOWN	0x01

// keys
#define _KBD_ESC	0x001b
#define _KBD_ENTER	0x000d
#define _KBD_LEFT	0x104b
#define _KBD_RIGHT	0x104d
#define _KBD_UP		0x1048
#define _KBD_DOWN	0x1050
#define _KBD_INS	0x1052
#define _KBD_DEL	0x1053
#define _KBD_HOME	0x1047
#define _KBD_END	0x104f
#define _KBD_PGUP	0x1049
#define _KBD_PGDN	0x1051
#define _KBD_F1		0x103b
#define _KBD_F2		0x103c
#define _KBD_F3		0x103d
#define _KBD_F4		0x103e
#define _KBD_F5		0x103f
#define _KBD_F6		0x1040
#define _KBD_F7		0x1041
#define _KBD_F8		0x1042
#define _KBD_F9		0x1043
#define _KBD_F10	0x1044
#define _KBD_BS		0x0008
#define _KBD_TAB	0x0009

// mods
#define _KBD_SHIFT	0x0100
#define _KBD_CAPS	0x0200
#define _KBD_CTRL	0x0400
#define _KBD_ALT	0x0800

// ctrl+'a'-'z' - special case, others could be achieved via _KBD_CTRL+<key>
#define _KBD_CTRL_A	0x0401
#define _KBD_CTRL_B	0x0402
#define _KBD_CTRL_C	0x0403
#define _KBD_CTRL_D	0x0404
#define _KBD_CTRL_E	0x0405
#define _KBD_CTRL_F	0x0406
#define _KBD_CTRL_G	0x0407
#define _KBD_CTRL_H	0x0408
#define _KBD_CTRL_I	0x0409
#define _KBD_CTRL_J	0x040a
#define _KBD_CTRL_K	0x040b
#define _KBD_CTRL_L	0x040c
#define _KBD_CTRL_M	0x040d
#define _KBD_CTRL_N	0x040e
#define _KBD_CTRL_O	0x040f
#define _KBD_CTRL_P	0x0410
#define _KBD_CTRL_Q	0x0411
#define _KBD_CTRL_R	0x0412
#define _KBD_CTRL_S	0x0413
#define _KBD_CTRL_T	0x0414
#define _KBD_CTRL_U	0x0415
#define _KBD_CTRL_V	0x0416
#define _KBD_CTRL_W	0x0417
#define _KBD_CTRL_X	0x0418
#define _KBD_CTRL_Y	0x0419
#define _KBD_CTRL_Z	0x041a

#endif
