//
// FTN message handling class
// Copyright (c) 1996-9 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "ftnmsg.h"
#include "_united.h"

#define _KLUDGE		0x01
#define MAX_LINE_SIZE	16384
#define _TOPT		"\001TOPT "
#define _FMPT		"\001FMPT "
#define _INTL		"\001INTL "
#define _MSGID		"\001MSGID: "

#define BULLETPROOF
// improves vitality, decreases speed

//#define AUTOLOCKTEXT
// allows not to care about proper ::LockText() calling, decreases speed

void FTNMessage::_read_body(void)
{
 _purge_body();
 _last_chain=&_starter;
 _origzone=_destzone=_destpoint=_origpoint=_timesread=_replyto=_nextreply=0;
 if(!(_tempo_str_ptr=new char[MAX_LINE_SIZE+1+1])) {state=msgNOMEM;return;}
 do
 {
  _tempo_file->getline(_tempo_str_ptr,MAX_LINE_SIZE,0x0d);
  _tempo_int=_tempo_file->peek();
  if(_tempo_int==EOF)
  {
   _tempo_int=0;
   state=msgEOF;
  }
  else
  {
   strcat(_tempo_str_ptr,"\015");
   if(!_tempo_int) _tempo_file->seekg(1+_tempo_file->tellg());
  }
  if(*_tempo_str_ptr==_KLUDGE)
   if(!strncmp(_tempo_str_ptr,_TOPT,5))
    _destpoint=atoi(_tempo_str_ptr+6);
   else
    if(!strncmp(_tempo_str_ptr,_FMPT,5))
     _origpoint=atoi(_tempo_str_ptr+6);
    else
     if(!strncmp(_tempo_str_ptr,_INTL,5))
     {
      _tempo_str_ptr_0=_tempo_str_ptr+6;
      _destzone=atoi(_tempo_str_ptr_0);
      while (*_tempo_str_ptr_0++!=' ');
      _origzone=atoi(_tempo_str_ptr_0);
     }
     else
      if(!strncmp(_tempo_str_ptr,_MSGID,8)&&strchr(_tempo_str_ptr+8,':')&&strchr(_tempo_str_ptr+8,'/'))
      {
       _origzone=atoi(_tempo_str_ptr_0=_tempo_str_ptr+7);
       while(*_tempo_str_ptr_0&&*++_tempo_str_ptr_0!=':');
       _orignet=atoi(++_tempo_str_ptr_0);
       while(*_tempo_str_ptr_0&&*++_tempo_str_ptr_0!='/');
       _orignode=atoi(++_tempo_str_ptr_0);
       while(*_tempo_str_ptr_0&&*++_tempo_str_ptr_0!='.'&&*_tempo_str_ptr_0!=' ');
       if(*_tempo_str_ptr_0=='.')
        _origpoint=atoi(++_tempo_str_ptr_0);
      }
  if(!InsertString(_tempo_str_ptr)) {LockText();delete[] _tempo_str_ptr;return;}
 }while(_tempo_int);
 LockText();
 if(strncmp(_body->Text,"AREA:",5))
  *_area=0;
 else
 {
#ifdef BULLETPROOF
  strncpy(_area,5+_body->Text,61);
  _area[60]=0;
#else
  strcpy(_area,5+_body->Text);
#endif
 }
 delete[] _tempo_str_ptr;
 sprintf(_to_address,"%d:%d/%d",_destzone,_destnet,_destnode);
 if(_destpoint) sprintf(_to_address+strlen(strcat(_to_address,".")),"%d",_destpoint);
 sprintf(_from_address,"%d:%d/%d",_origzone,_orignet,_orignode);
 if(_origpoint) sprintf(_from_address+strlen(strcat(_from_address,".")),"%d",_origpoint);
 if(*_area&&_area[strlen(_area)-1]==0x0d) _area[strlen(_area)-1]=0;
}

void FTNMessage::ReadFromFile(char*name)
{
 state=msgOK;
 if(!(_tempo_file=new fstream(name,ios::in|ios::fakebinary))) {state=msgNOMEM;return;}
 _tempo_file->read(_from,36);
 _tempo_file->read(_to,36);
 _tempo_file->read(_subj,72);
 _tempo_file->read(_datetime,20);
 _tempo_file->read((char*)&_timesread,2);
 _tempo_file->read((char*)&_destnode,2);
 _tempo_file->read((char*)&_orignode,2);
 _tempo_file->read((char*)&_cost,2);
 _tempo_file->read((char*)&_orignet,2);
 _tempo_file->read((char*)&_destnet,2);
 _tempo_file->seekg(8,ios::cur);
 _tempo_file->read((char*)&_replyto,2);
 _tempo_file->read((char*)&_attribute,2);
 _tempo_file->read((char*)&_nextreply,2);
 _read_body();
 delete _tempo_file;
}

char FTNMessage::ReadPacked(fstream*_in_file)
{
 state=msgOK;
 _in_file->read((char*)&_orignode,2);
 if(_orignode!=2) return 0;
 _tempo_file=_in_file;
 _in_file->read((char*)&_orignode,2);
 _in_file->read((char*)&_destnode,2);
 _in_file->read((char*)&_orignet,2);
 _in_file->read((char*)&_destnet,2);
 _in_file->read((char*)&_attribute,2);
 _in_file->read((char*)&_cost,2);
 _in_file->read(_datetime,20);
#ifdef BULLETPROOF
#define READSTRING(A,B) {_tempo_str_ptr=A;_tempo_int=0;do {if(_tempo_int++==B){*--_tempo_str_ptr=0;break;}_in_file->read(_tempo_str_ptr,1);} while(*_tempo_str_ptr++);}
 READSTRING(_to,36)
 READSTRING(_from,36)
 READSTRING(_subj,72)
#undef READSTRING
#else
#define READSTRING(A) {_tempo_str_ptr=A; do _in_file->read(_tempo_str_ptr,1); while(*_tempo_str_ptr++);}
 READSTRING(_to)
 READSTRING(_from)
 READSTRING(_subj)
#undef READSTRING
#endif
 _read_body();
 return 1;
}

void FTNMessage::_write_body(void)
{
 for(_tempo_chain=_body;_tempo_chain;_tempo_chain=_tempo_chain->Next)
  _tempo_file->write(_tempo_chain->Text,strlen(_tempo_chain->Text));
 *_tempo_file<<'\000';
}

void FTNMessage::WriteToFile(char*name)
{
 state=msgOK;
 if(!(_tempo_file=new fstream(name,ios::out|ios::fakebinary))) {state=msgNOMEM;return;}
 _tempo_file->write(_from,36);
 _tempo_file->write(_to,36);
 _tempo_file->write(_subj,72);
 _tempo_file->write(_datetime,20);
 _tempo_file->write((char*)&_timesread,2);
 _tempo_file->write((char*)&_destnode,2);
 _tempo_file->write((char*)&_orignode,2);
 _tempo_file->write((char*)&_cost,2);
 _tempo_file->write((char*)&_orignet,2);
 _tempo_file->write((char*)&_destnet,2);
 _tempo_file->seekp(8,ios::cur);
 _tempo_file->write((char*)&_replyto,2);
 _tempo_file->write((char*)&_attribute,2);
 _tempo_file->write((char*)&_nextreply,2);
 _write_body();
 delete _tempo_file;
}

void FTNMessage::WritePacked(fstream*_out_file)
{
 state=msgOK;
 _timesread=2;
 _tempo_file=_out_file;
 _out_file->write((char*)&_timesread,2);
 _out_file->write((char*)&_orignode,2);
 _out_file->write((char*)&_destnode,2);
 _out_file->write((char*)&_orignet,2);
 _out_file->write((char*)&_destnet,2);
 _out_file->write((char*)&_attribute,2);
 _out_file->write((char*)&_cost,2);
 _out_file->write(_datetime,20);
 _out_file->write(_to,1+strlen(_to));
 _out_file->write(_from,1+strlen(_from));
 _out_file->write(_subj,1+strlen(_subj));
 _write_body();
}

void FTNMessage::_boot(void)
{
 state=msgOK;
 _starter.Prev=NULL;
 _starter.Text=NULL;
 _last_chain=&_starter;
}

FTNMessage::FTNMessage()
{
 _boot();
}

FTNMessage::FTNMessage(FTNMessage*tpl)
{
 _boot();
 _cost               =tpl->_cost;
 _orignet            =tpl->_orignet;
 _destnet            =tpl->_destnet;
 _replyto            =tpl->_replyto;
 _destnode           =tpl->_destnode;
 _orignode           =tpl->_orignode;
 _destzone           =tpl->_destzone;
 _origzone           =tpl->_origzone;
 _attribute          =tpl->_attribute;
 _nextreply          =tpl->_nextreply;
 _timesread          =tpl->_timesread;
 _destpoint          =tpl->_destpoint;
 _origpoint          =tpl->_origpoint;
 strcpy(_to          ,tpl->_to);
 strcpy(_from        ,tpl->_from);
 strcpy(_subj        ,tpl->_subj);
 strcpy(_area        ,tpl->_area);
 strcpy(_datetime    ,tpl->_datetime);
 strcpy(_to_address  ,tpl->_to_address);
 strcpy(_from_address,tpl->_from_address);
}

void FTNMessage::_purge_body(void)
{
 for(_tempo_chain=_last_chain->Prev;_tempo_chain;_tempo_chain=_tempo_chain->Prev)
 {
  if(_tempo_chain->Next->Text) free(_tempo_chain->Next->Text);
  delete _tempo_chain->Next;
 }
}

FTNMessage::~FTNMessage()
{
 _purge_body();
}

char FTNMessage::InsertString(char*txt)
{
 state=msgOK;
 if(!(_last_chain->Next=new TextChain)) {state=msgNOMEM;return 0;}
 _last_chain->Next->Prev=_last_chain;
 _last_chain=_last_chain->Next;
#ifdef AUTOLOCKTEXT
 _last_chain->Next=NULL;
 _body=_starter.Next;
#endif
 if(!(_last_chain->Text=strdup(txt))) {state=msgNOMEM;return 0;}
 return 1;
}

char FTNMessage::InsertStringInChain(TextChain*before,char*txt)
{
 state=msgOK;
 if(!(before->Next->Prev=new TextChain)) {state=msgNOMEM;return 0;}
 before->Next->Prev->Prev=before;
 before->Next->Prev->Next=before->Next;
 before->Next=before->Next->Prev;
 if(!(before->Next->Text=strdup(txt))) {state=msgNOMEM;return 0;}
 return 1;
}

void FTNMessage::LockText(void)
{
 _last_chain->Next=NULL;
 _body=_starter.Next;
}
