//
// FTN message handling class
// Copyright (c) 1996-9 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __RTN_FTNMSG_H
#define __RTN_FTNMSG_H

#include <fstream.h>
#include "types.h"

#define msgOK    0x10
#define msgEOF   0x11
#define msgNOMEM 0x12

class FTNMessage
{
 fstream *_tempo_file;
 char *_tempo_str_ptr,*_tempo_str_ptr_0;
 int _tempo_int;
 void _read_body(void);
 void _write_body(void);
 TextChain*_tempo_chain,_starter;
 void _purge_body(void);
 void _boot(void);
public:
 FTNMessage();
 FTNMessage(FTNMessage*);
 ~FTNMessage();
 TextChain*_body,*_last_chain;
 char state,_from[36],_to[36],_subj[72],_datetime[20];
 short int _timesread,_destnode,_orignode,_cost,_orignet,_destnet,_destzone,_origzone,_destpoint,_origpoint,_replyto,_attribute,_nextreply;
 char _area[61],_from_address[24],_to_address[24];
 void LockText(void);
 char InsertString(char*);
 void ReadFromFile(char*);
 void WriteToFile(char*);
 char ReadPacked(fstream*);
 void WritePacked(fstream*);
 char InsertStringInChain(TextChain*,char*);
};

#endif
