//
// FTN Type2+ packet handling class
// Copyright (c) 1996-9 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __RTN_FTNPKT_H
#define __RTN_FTNPKT_H

#include "ftnmsg.h"

#define pktOK             0x20
#define pktUNEXPECTED_EOF 0x21
#define pktMISSING_EOF    0x22
#define pktNOMEM          0x23
#define pktBADPKT         0x24

struct FTNMsgList
{
 FTNMessage*msg;
 FTNMsgList*next,*prev;
 long seekpos;
 char from[36],to[36],subj[72],area[61],datetime[20];
};

class FTNPacket
{
 FTNMessage*_replica; 
 FTNMsgList*_tempo_msg,*_tempo_msg_0;
 fstream*_tempo_file,*_tempo_file_0;
 short int _tempo_int;
 char *_tempo_str_ptr,*_tempo_str_ptr_0;
 void _boot(void);
 char _read_init(char*);
 void reload(void);
 char seektonext(void);
public:
 short int _orignode,_destnode,_year,_month,_day,_hour,_minute,_second,_baud,_orignet,_destnet,_AuxNet,_CW,_origZone,_destZone,_origPoint,_destPoint,_prodrev0,_prodrev1;
 char psw[8],psd[4],_to_address[24],_from_address[24], state;
 short int _current_msg_num,_total_msg_num;
 FTNMsgList*_first_msg;
 FTNMessage*_current_msg;
 void DeleteCurrent(void);
 void WriteChunk(void);
 void WriteChunkFixup(void);
 void WriteChunkInit(char*);
 void WriteChunkDone(void);
 void InsertChunk(FTNMessage*);
 char SeekCurrent(short int);
 char IncCurrent(void);
 char DecCurrent(void);
 char ReadFlat(char*);
 char ReadLookup(char*);
 void Write(char*);
 void Dispell(void);
 void DirtyDispell(void);
 void Insert(FTNMessage*);
 FTNPacket();
 FTNPacket(FTNPacket*);
 ~FTNPacket();
};

#endif
