//
// Neslie
// Copyright (c) 1996-2000 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "_united.h"
#include "constuff.h"
#include "_version.h"
#include "viewer.h"

#define _ifaceHdrSize 6
#define _ifaceHdrOfs  8
#define HdrLines    0x09
#define HdrTitles   0x07
#define HdrDate     0x07
#define HdrMsgInfo  0x07
#define HdrMsgOf    0x0e
#define HdrPsw      0x0e
#define HdrSize     0x0e
#define HdrPercent  0x0e
#define HdrFromTo   0x0e
#define HdrArea     0x0e
#define MsgNormal   0x07
#define MsgKludge   0x08
#define MsgQuote    0x0e
#define MsgArea     0x04
#define MsgSeenby   0x03
#define MsgOrigin   0x0f
#define MsgTearline 0x0f
#define MsgTagline  0x0f
#define MsgAttrOff  0x07
#define MsgAttrOn   0x0f
#define BrwBorder   0x0c
#define BrwNormal   0x07
#define BrwSelect   0x1f
#define BrwSubj     0x0e

void Viewer::DoBrowse(FTNPacket*pkt)
{
 char _tempo,*_tempo_str;
 int _tempo_int,fnsize=0,tnsize=0,ansize=0,dnsize=0;
 int _initial_msg=pkt->_current_msg_num,_selected=pkt->_current_msg_num,_first_line=0,_lines_to_write=pkt->_total_msg_num;
 FTNMsgList*_tempo_msg,*_hashed_msg=pkt->_first_msg,*_tempo_msg_0=pkt->_first_msg;

 if(*(pkt->_first_msg->area))
  for(_tempo_msg=pkt->_first_msg;_tempo_msg;_tempo_msg=_tempo_msg->next)
  {
   if((int)strlen(_tempo_msg->from)>fnsize) fnsize=strlen(_tempo_msg->from);
   if((int)strlen(_tempo_msg->to)>tnsize) tnsize=strlen(_tempo_msg->to);
   if((int)strlen(_tempo_msg->area)>ansize) ansize=strlen(_tempo_msg->area);
  }
 else
  for(_tempo_msg=pkt->_first_msg;_tempo_msg;_tempo_msg=_tempo_msg->next)
  {
   if((int)strlen(_tempo_msg->from)>fnsize) fnsize=strlen(_tempo_msg->from);
   if((int)strlen(_tempo_msg->to)>tnsize) tnsize=strlen(_tempo_msg->to);
   if((int)strlen(_tempo_msg->subj)>ansize) ansize=strlen(_tempo_msg->subj);
  }

 if(++fnsize>((cMaxX-2)/3)) fnsize=(cMaxX-2)/3;
 fnsize+=3;
 if(++tnsize>((cMaxX-2)/3)) tnsize=(cMaxX-2)/3;
 tnsize+=3+fnsize;
 ansize+=3+tnsize;
 if(ansize>(cMaxX-2)) ansize=cMaxX-2;
 else if(((cMaxX-2)-ansize)>22) {ansize+=22;dnsize=tnsize+22;}

 if(_lines_to_write>cMaxY-(_ifaceHdrSize+4)) _lines_to_write=cMaxY-(_ifaceHdrSize+4);
 for(_tempo=0;_tempo<cMaxY-10;_tempo++) c_filla(BrwNormal,cMaxX-2,1,_tempo+8);
 c_fillc(0xc4,cMaxX-15,14,7);
 c_putc("/",1,7,7);
 c_putc("\264",1,1,7);
 c_putc("\303",1,13,7);
 c_fillc(0xc4,cMaxX-2,1,cMaxY-2);
 c_filla(BrwBorder,cMaxX-2,1,7);
 c_filla(BrwBorder,cMaxX-2,1,cMaxY-2);
 for(_tempo=0;_tempo<cMaxY-8;_tempo++)
 {
  c_filla(BrwBorder,1,0,_tempo+7);
  c_filla(BrwBorder,1,cMaxX-1,_tempo+7);
  c_putc("\263",1,0,_tempo+7);
  c_putc("\263",1,cMaxX-1,_tempo+7);
 }
 c_putc("\332",1,0,7);
 c_putc("\277",1,cMaxX-1,7);
 c_putc("\300",1,0,cMaxY-2);
 c_putc("\331",1,cMaxX-1,cMaxY-2);
 _tempo_str=new char[255];
 while(_selected>=_first_line+_lines_to_write)
 {
  _first_line++;
  _tempo_msg_0=_tempo_msg_0->next;
 }
 for(_tempo_int=_selected;_tempo_int--;_hashed_msg=_hashed_msg->next);
 do
 {
// write the text
  for(_tempo_msg=_tempo_msg_0,_tempo_int=0;_tempo_int<_lines_to_write;_tempo_int++)
  {
   strcpy(_tempo_str," ");
   strcat(_tempo_str,_tempo_msg->from);
   memset(_tempo_str+strlen(_tempo_str),' ',fnsize-strlen(_tempo_str));
   _tempo_str[fnsize]=0;
   strcat(_tempo_str,_tempo_msg->to);
   memset(_tempo_str+strlen(_tempo_str),' ',tnsize-strlen(_tempo_str));
   _tempo_str[tnsize]=0;
   
   if(dnsize)
   {
    strcat(_tempo_str,_tempo_msg->datetime);
    memset(_tempo_str+strlen(_tempo_str),' ',dnsize-strlen(_tempo_str));
    _tempo_str[dnsize]=0;
   }

   if(*_tempo_msg->area)
    {
     strcat(_tempo_str,_tempo_msg->area);
     if(ansize<(cMaxX-2))
     {
      memset(_tempo_str+strlen(_tempo_str),' ',ansize-strlen(_tempo_str));
      _tempo_str[ansize]=0;
      strcat(_tempo_str,_tempo_msg->subj);
     }
    }
   else
    strcat(_tempo_str,_tempo_msg->subj);

   if(strlen(_tempo_str)<(unsigned)(cMaxX-2))
    memset(_tempo_str+strlen(_tempo_str),' ',(cMaxX-2)-strlen(_tempo_str));
   c_putc(_tempo_str,cMaxX-2,1,_tempo_int+_ifaceHdrSize+2);
   _tempo_msg=_tempo_msg->next;
  }
// and pad it
  memset(_tempo_str,' ',cMaxX-2);
  while(_tempo_int<cMaxY-(_ifaceHdrSize+4))
   c_putc(_tempo_str,cMaxX-2,1,(_tempo_int++)+_ifaceHdrSize+2);
  do
  {
   c_filla(BrwSelect,cMaxX-2,1,_selected-_first_line+_ifaceHdrSize+2);
   c_fillc(' ',5,2,_ifaceHdrSize+1);
   c_fillc(' ',5,8,_ifaceHdrSize+1);
   sprintf(_tempo_str,"%d",1+_selected);
   c_puts(_tempo_str,7-strlen(_tempo_str),_ifaceHdrSize+1);
   sprintf(_tempo_str,"%d",pkt->_total_msg_num);
   c_puts(_tempo_str,13-strlen(_tempo_str),_ifaceHdrSize+1);
   _tempo=strlen(_hashed_msg->subj);
   c_writeca(_hashed_msg->subj,BrwSubj,_tempo,(cMaxX-_tempo)/2,cMaxY-2);
   c_putc("\264",1,(cMaxX-_tempo)/2-1,cMaxY-2);
   c_putc("\303",1,(cMaxX-_tempo)/2+_tempo,cMaxY-2);
   _tempo=0;
   do
   {
    switch(c_getkey())
    {
     case _KBD_ENTER:_tempo=BA_LOAD;break;
     case 'q'       :_act=ACTION_QUIT;
     case _KBD_ESC  :_tempo=BA_QUIT;break;
     case _KBD_DEL  :_tempo=BA_KILL;break;
     case _KBD_UP   :if(_selected) _tempo=BA_PREV;break;
     case _KBD_HOME :if(_selected) _tempo=BA_HOME;break;
     case _KBD_PGUP :if(_selected) _tempo=BA_PGUP;break;
     case _KBD_END  :if(_selected<pkt->_total_msg_num-1) _tempo=BA_END;break;
     case _KBD_PGDN :if(_selected<pkt->_total_msg_num-1) _tempo=BA_PGDN;break;
     case _KBD_DOWN :if(_selected<pkt->_total_msg_num-1) _tempo=BA_NEXT;
    }
   }while(!_tempo);
   c_filla(BrwNormal,cMaxX-2,1,_selected-_first_line+_ifaceHdrSize+2);
   c_filla(BrwBorder,cMaxX-2,1,cMaxY-2);
   c_fillc(0xc4,cMaxX-2,1,cMaxY-2);
   switch(_tempo)
   {
    case BA_PGUP:if(_first_line) break;
    case BA_HOME:_selected=0;_hashed_msg=pkt->_first_msg;
                 if(_selected>=_first_line) _tempo=0;break;
    case BA_PREV:_hashed_msg=_hashed_msg->prev;
                 if(--_selected>=_first_line) _tempo=0;break;
    case BA_PGDN:if(_first_line+_lines_to_write<pkt->_total_msg_num) break;
    case BA_END :_selected=pkt->_total_msg_num-1;
                 while(_hashed_msg->next) _hashed_msg=_hashed_msg->next;
                 if(_selected<_lines_to_write+_first_line) _tempo=0;break;
    case BA_NEXT:_hashed_msg=_hashed_msg->next;
                 if(++_selected<_lines_to_write+_first_line) _tempo=0;break;
   }
  }while(!_tempo);
  switch(_tempo)
  {
   case BA_HOME:_first_line=0;_tempo_msg_0=pkt->_first_msg;break;
   case BA_PGUP:_tempo_int=_lines_to_write-1>_first_line?_first_line:_lines_to_write-1;
                _first_line-=_tempo_int;
                _selected-=_tempo_int;
                while(_tempo_int--)
                {
                 _hashed_msg=_hashed_msg->prev;
                 _tempo_msg_0=_tempo_msg_0->prev; 
                }
                break;
   case BA_PGDN:_tempo_int=_lines_to_write>pkt->_total_msg_num-_first_line-_lines_to_write?pkt->_total_msg_num-_first_line-_lines_to_write:_lines_to_write;
                _first_line+=_tempo_int;
                _selected+=_tempo_int;
                while(_tempo_int--)
                {
                 _hashed_msg=_hashed_msg->next;
                 _tempo_msg_0=_tempo_msg_0->next; 
                }
                break;
   case BA_END: while(_first_line+_lines_to_write<=_selected)
                {
                 _first_line++;
                 _tempo_msg_0=_tempo_msg_0->next;
                }
                break;
   case BA_KILL:if(_selected==_first_line)
                 if(_first_line)
                 {
                  _tempo_msg_0=_tempo_msg_0->prev;
                  _first_line--;
                 }
                 else
                  _tempo_msg_0=_tempo_msg_0->next;
                pkt->SeekCurrent(_selected);
                if(_initial_msg&&_selected<=_initial_msg) _initial_msg--;
                if(_selected==_first_line+_lines_to_write-1)
                {
                 _selected--;
                 _hashed_msg=_hashed_msg->prev;
                }
                else
                 _hashed_msg=_hashed_msg->next;
                pkt->DeleteCurrent();
                _was_changed=1;
                if(!pkt->_total_msg_num)
                 _tempo=BA_QUIT;
                else
                 if(_lines_to_write>pkt->_total_msg_num)
                  _lines_to_write=pkt->_total_msg_num;
                 else
                  if(_first_line&&_first_line+_lines_to_write>pkt->_total_msg_num)
                  {
                   _tempo_msg_0=_tempo_msg_0->prev;
                   _first_line--;
                  }
                break;
   case BA_NEXT:_first_line++;
                _tempo_msg_0=_tempo_msg_0->next;
                break;
   case BA_PREV:_first_line--;
                _tempo_msg_0=_tempo_msg_0->prev;
  }
 }while(_tempo!=BA_LOAD&&_tempo!=BA_QUIT);
 if(pkt->_total_msg_num)
  pkt->SeekCurrent(_tempo==BA_QUIT?_initial_msg:_selected);
 delete[] _tempo_str;
}

void Viewer::ViewMsg(char*name)
{
 FTNMessage CurMsg;
 CurMsg.ReadFromFile(name);
 strcpy(_tempo_str,TITLE);
 strcat(_tempo_str," - ");
 strcat(_tempo_str,name);
 c_init(_tempo_str);
 DrawHdr();
 do _act=ShowMsg(&CurMsg,NO_NEXT|NO_PREV); while(_act!=ACTION_QUIT&&_act!=ACTION_DELETE);
 if(_act==ACTION_DELETE) remove(name);
 c_done();
}

char Viewer::ViewPkt(char*name)
{
 _was_changed=0;
 FTNPacket CurPkt;
 if(!CurPkt.ReadLookup(name)) return 0;
 if(CurPkt._current_msg)
 {
  strcpy(_tempo_str,TITLE);
  strcat(_tempo_str," - ");
  strcat(_tempo_str,name);
  c_init(_tempo_str);
  if(CurPkt.state!=pktOK)
  if(CurPkt.state==pktUNEXPECTED_EOF) infoBox("Packet Corrupted",(cMaxX-20)/2,(cMaxY-3)/2,"Unexpected EOF");
  else if(CurPkt.state==pktMISSING_EOF) infoBox("Packet Corrupted",(cMaxX-20)/2,(cMaxY-3)/2,"Missing EOF");
       else infoBox("Malfunction",(cMaxX-21)/2,(cMaxY-3)/2,"Things went wrong");
  DrawHdr();
  c_filla(HdrMsgOf,11,1,0);
  c_putc("/",1,6,0);
  c_putc("\264",1,0,0);
  c_putc("\303",1,12,0);
  c_putc("\303",1,cMaxX-1,0);
  strcpy(_tempo_str,CurPkt._from_address);
  strcat(_tempo_str," -> ");
  strcat(_tempo_str,CurPkt._to_address);
  _act=1;
  if(*CurPkt.psw)
  {
   while(_act<8&&CurPkt.psw[_act]) _act++;
   c_writeca(CurPkt.psw,HdrPsw,_act,cMaxX-_act-1,0);
   c_putc("\264",1,cMaxX-_act-2,0);
   c_putc("\303",1,cMaxX-_act-4,0);
   _act+=4;
  }
  c_writeca(_tempo_str,HdrFromTo,strlen(_tempo_str),cMaxX-strlen(_tempo_str)-_act,0);
  c_putc("\264",1,cMaxX-_act-strlen(_tempo_str)-1,0);
  do
  {
   c_fillc(' ',5,1,0);
   c_fillc(' ',5,7,0);
   sprintf(_tempo_str,"%d",1+CurPkt._current_msg_num);
   c_puts(_tempo_str,6-strlen(_tempo_str),0);
   sprintf(_tempo_str,"%d",CurPkt._total_msg_num);
   c_puts(_tempo_str,12-strlen(_tempo_str),0);
   if(!CurPkt._current_msg_num) _act=NO_PREV; else _act=0;
   if(1+CurPkt._current_msg_num==CurPkt._total_msg_num) _act|=NO_NEXT;
   _act=ShowMsg(CurPkt._current_msg,_act);
   switch(_act)
   {
    case ACTION_PREV  :CurPkt.DecCurrent();                        break;
    case ACTION_NEXT  :CurPkt.IncCurrent();                        break;
    case ACTION_FIRST :CurPkt.SeekCurrent(0);                      break;
    case ACTION_LAST  :CurPkt.SeekCurrent(CurPkt._total_msg_num-1);break;
    case ACTION_DELETE:CurPkt.DeleteCurrent();_was_changed=1;      break;
    case ACTION_BROWSE:DoBrowse(&CurPkt);
   }
  } while(CurPkt._current_msg&&_act!=ACTION_QUIT);
  if(_was_changed) CurPkt.Write(name);
 }
 CurPkt.Dispell();
 c_done();
 return 1;
}

void Viewer::DrawHdr(void)
{
 for(_act=0;_act<_ifaceHdrSize;_act++)
 {
  c_filla(HdrLines,cMaxX,0,_act);
  c_fillc(' ',     cMaxX,0,_act);
 }
 c_filla(HdrMsgInfo,59,_ifaceHdrOfs,_ifaceHdrSize-4);
 c_filla(HdrMsgInfo,59,_ifaceHdrOfs,_ifaceHdrSize-3);
 c_filla(HdrMsgInfo,71,_ifaceHdrOfs,_ifaceHdrSize-2);
 c_filla(HdrSize,4,1,_ifaceHdrSize-1);
 c_filla(HdrPercent,4,8,_ifaceHdrSize-1);
 c_fillc(0xc4,cMaxX,0,0);
 c_fillc(0xc4,cMaxX,0,5);
 for(_act=0;_act<_ifaceHdrSize-2;_act++) c_filla(HdrTitles,6,1,1+_act);
 c_putc("Flag : Pvt Cra Rcv Snt Att Tfs Orp K/s Loc Hld Rsv Frq RRq RRc ARq URq",70,1,1);
 c_putc("From :",6,1,2);
 c_putc("To   :",6,1,3);
 c_putc("Subj :",6,1,4);
 c_putc("\264",1,0,5);
 c_putc("\303",1,5,5);
 c_putc("\264",1,7,5);
 c_putc("\303",1,12,5);
 if(cMaxX>87)
  c_filla(HdrDate,19,60+8,2);
 else
  c_filla(HdrDate,19,cMaxX-20,5);
 c_putc("%",1,11,_ifaceHdrSize-1);
}

#define TAB_SIZE 8

char Viewer::ShowMsg(FTNMessage*msg,char showmode)
{
 char*_cache0,*_cache1;
// scroller coaster ;)
 ScrollNode*firstnode,*really1stnode;
 int visiblelines=cMaxY-_ifaceHdrSize,totallines,cachenum;
 unsigned char _local_act=0xff,_do_redraw=1;
// draw msg header
 for(cachenum=0;cachenum<2;cachenum++) c_fillc(' ',59,_ifaceHdrOfs,cachenum+_ifaceHdrSize-4);
 c_fillc(' ',72,              _ifaceHdrOfs,_ifaceHdrSize-2);
 c_puts(msg->_from,           _ifaceHdrOfs,_ifaceHdrSize-4);
 c_puts(msg->_to,             _ifaceHdrOfs,_ifaceHdrSize-3);
 c_puts(msg->_subj,           _ifaceHdrOfs,_ifaceHdrSize-2);
 c_puts(msg->_from_address,36+_ifaceHdrOfs,_ifaceHdrSize-4);
 if(!*(msg->_area)) c_puts(msg->_to_address,  36+_ifaceHdrOfs,_ifaceHdrSize-3);
 c_fillc(' ',4,1,_ifaceHdrSize-1);
 if(cMaxX>99) cachenum=62; else cachenum=45;
 c_filla(HdrLines,cachenum,14,_ifaceHdrSize-1);
 c_fillc(0xc4,cachenum,14,_ifaceHdrSize-1);
 if(*(msg->_area))
 {
  cachenum=strlen(msg->_area);
  c_putc("\264",1,14,_ifaceHdrSize-1);
  c_putc("\303",1,15+cachenum,_ifaceHdrSize-1);
  c_writeca(msg->_area,HdrArea,cachenum,15,_ifaceHdrSize-1);
 }
 if(cMaxX>87)
  c_puts(msg->_datetime,60+8,2);
 else
  c_puts(msg->_datetime,cMaxX-20,5);
 for(cachenum=0;cachenum<16;cachenum++)
  if((msg->_attribute)&(0x0001U<<cachenum))
   c_filla(MsgAttrOn,3,8+4*cachenum,1);
  else
   c_filla(MsgAttrOff,3,8+4*cachenum,1);
// parse
 temponode=new ScrollNode;
 temponode->c=new char[cMaxX+1];
 temponode->a=MsgNormal;
 temponode->next=temponode->prev=NULL;
 temponode->num=0;
 really1stnode=temponode;
 TextChain*tch=msg->_body;
 for(cachenum=0;tch;tch=tch->Next)
 {
  cachenum+=(totallines=1+strlen(tch->Text)); // CR+strlen
  for(_cache0=tch->Text,_cache1=_swapper;totallines--;_cache0++)
   if(*_cache0==0x09) for(_act=TAB_SIZE;_act--;) *_cache1++=' ';
   else if(*_cache0!=0x0a) *_cache1++=*_cache0;
  _cache_string(_swapper);
 }
 totallines=temponode->num;
 temponode->prev->next=0;
 delete[] temponode->c;
 delete temponode;
 sprintf(_tempo_str,"%d",cachenum);
 if(strlen(_tempo_str)>4) 
 {
  _tempo_str[strlen(_tempo_str)-3]='k';
  _tempo_str[strlen(_tempo_str)-2]=0;
 }
 c_puts(_tempo_str,5-strlen(_tempo_str),_ifaceHdrSize-1);
 for(cachenum=totallines+_ifaceHdrSize;cachenum<cMaxY;cachenum++)
 {
  c_filla(MsgNormal,cMaxX,0,cachenum);
  c_fillc(' ',cMaxX,0,cachenum);
 }
// do scroll
 firstnode=really1stnode;
 while (_local_act==0xff)
 {
  if(_do_redraw)
  {
   for(temponode=firstnode,cachenum=0;temponode&&cachenum<visiblelines;temponode=temponode->next,cachenum++)
    c_writeca(temponode->c,temponode->a,cMaxX,0,_ifaceHdrSize+cachenum);
   strcpy(_tempo_str,"  ");
   sprintf(_tempo_str+2,"%d",totallines>visiblelines?(100*(firstnode->num+visiblelines)/totallines):100);
   c_putc(_tempo_str-3+strlen(_tempo_str),3,8,_ifaceHdrSize-1);
  }
  else
   _do_redraw=1;
  switch(c_getkey())
  {
   case 'e'       :
   case _KBD_F2   :strcpy(_tempo_str,"exported.msg");
                   if(askString("Save this message as:",cMaxX/2-16,cMaxY/2-1,_tempo_str,32,254)) msg->WriteToFile(_tempo_str);
                   for(cachenum=0;cachenum<3;cachenum++) c_filla(0x00,34,cMaxX/2-16,cachenum+cMaxY/2-1);
                   break;
   case 's'       :
   case _KBD_F4   :strcpy(_tempo_str,"exported.txt");
                   if(askString("Export to text as:",cMaxX/2-16,cMaxY/2-1,_tempo_str,32,254))
                   {
                    fstream*dump=new fstream(_tempo_str,ios::out|ios::fakebinary);
                    strcpy(_tempo_str,"\xc4");
                    if(*(msg->_area))
                    {
                     strcat(_tempo_str," ");
                     strcat(_tempo_str,msg->_area);
                     strcat(_tempo_str," ");
                    }
                    while(strlen(_tempo_str)<cMaxX) strcat(_tempo_str,"\xc4");
                    dump->write(_tempo_str,cMaxX); dump->write("\n",1);
                    strcat(strcpy(_tempo_str," From : "),msg->_from);
                    while(strlen(_tempo_str)<44) strcat(_tempo_str," ");
                    strcat(_tempo_str,msg->_from_address);
                    if(cMaxX>87)
                    {
                     while(strlen(_tempo_str)<68) strcat(_tempo_str," ");
                     strcat(_tempo_str,msg->_datetime);
                    }
                    dump->write(_tempo_str,strlen(_tempo_str)); dump->write("\n",1);
                    strcat(strcpy(_tempo_str," To   : "),msg->_to);
                    if(!*(msg->_area))
                    {
                     while(strlen(_tempo_str)<44) strcat(_tempo_str," ");
                     strcat(_tempo_str,msg->_to_address);
                    }
                    dump->write(_tempo_str,strlen(_tempo_str)); dump->write("\n",1);
                    strcat(strcpy(_tempo_str," Subj : "),msg->_subj);
                    dump->write(_tempo_str,strlen(_tempo_str)); dump->write("\n",1);
                    for(cachenum=0;cachenum<cMaxX-20;cachenum++) dump->write("\xc4",1);
                    if(cMaxX>87)
                     for(cachenum=0;cachenum<19;cachenum++) dump->write("\xc4",1);
                    else
                     dump->write(msg->_datetime,19);
                    dump->write("\xc4\n",2);
                    for(temponode=really1stnode;temponode;temponode=temponode->next,dump->write("\n",1))
                     if(*(temponode->c)==0x01)
                     {
                      dump->write("@",1);
#define WRITE_LINE(a,b) {int z=b;while(z&&(*(a+z-1)==' '))z--;dump->write(a,z);}
		      WRITE_LINE(1+temponode->c,cMaxX-1)
                     }
                     else
		      WRITE_LINE(temponode->c,cMaxX)
                    delete dump;
                   }
                   for(cachenum=0;cachenum<3;cachenum++) c_filla(0x00,34,cMaxX/2-16,cachenum+cMaxY/2-1);
                   break;
   case 'q'       :
   case _KBD_ESC  :_local_act=ACTION_QUIT;	break;
   case _KBD_DEL  :_local_act=ACTION_DELETE;	break;
   case _KBD_ENTER:_local_act=ACTION_BROWSE;	break;
   case _KBD_LEFT :if(!(showmode&NO_PREV)) _local_act=ACTION_PREV;	else _do_redraw=0;	break;
   case _KBD_RIGHT:if(!(showmode&NO_NEXT)) _local_act=ACTION_NEXT;	else _do_redraw=0;	break;
   case 'f'       :if(!(showmode&NO_PREV)) _local_act=ACTION_FIRST;	else _do_redraw=0;	break;
   case 'l'       :if(!(showmode&NO_NEXT)) _local_act=ACTION_LAST;	else _do_redraw=0;	break;
   case _KBD_UP   :if(firstnode->prev) firstnode=firstnode->prev;	else _do_redraw=0;	break;
   case _KBD_DOWN :if(firstnode->num+visiblelines<totallines) firstnode=firstnode->next; else _do_redraw=0; break;
   case _KBD_PGUP :if(firstnode->prev)
                    for(cachenum=cMaxY-6;cachenum&&firstnode->prev;firstnode=firstnode->prev,cachenum--);
		   else _do_redraw=0;
		   break;
   case _KBD_PGDN :if(firstnode->num+visiblelines<totallines)
                    for(cachenum=cMaxY-6;cachenum&&firstnode->num+visiblelines<totallines;firstnode=firstnode->next,cachenum--);
		   else _do_redraw=0;
		   break;
   case _KBD_HOME :if(firstnode->prev) firstnode=really1stnode; else _do_redraw=0; break;
   case _KBD_END  :if(firstnode->num+visiblelines<totallines)
                    while(firstnode->num+visiblelines<totallines) firstnode=firstnode->next;
		   else _do_redraw=0;
		   break;
   default        :_do_redraw=0;
  }
 }
 temponode=really1stnode;
 while(temponode)
 {
  firstnode=temponode;
  temponode=temponode->next;
  delete[] firstnode->c;
  delete firstnode;
 }
 return _local_act;
}

void Viewer::_cache_string(char*text)
{
 char diver;
 int _pos,_p2;

 _pos=strlen(text);
 if(_pos<=cMaxX)
 {
  strcpy(temponode->c,text);
  if(temponode->c[_pos-1]==0x0d) _pos--;
  for(;_pos<cMaxX;_pos++) temponode->c[_pos]=' ';
  diver=0;
 }
 else
 {
  for(_pos=cMaxX-1;_pos!=-1;_pos--) if(text[_pos]==' ') break;
  if(_pos<1) _pos=cMaxX;
  strncpy(temponode->c,text,_pos);
  for(_p2=_pos;_p2<cMaxX;_p2++) temponode->c[_p2]=' ';
  diver=1;
 }
 temponode->c[cMaxX]=0;
 if(temponode->c[0]==0x01) temponode->a=MsgKludge;
 else
  if(!temponode->num&&!strncmp(temponode->c,"AREA:",5)) temponode->a=MsgArea;
  else
   if(!strnicmp(temponode->c,"SEEN-BY:",8)) temponode->a=MsgSeenby;
   else
    if(strchr(temponode->c,'>')&&(strchr(temponode->c,'>')-temponode->c)<6) temponode->a=MsgQuote;
    else
     if(!strncmp(temponode->c," * Origin:",10)) temponode->a=MsgOrigin;
     else
      if((!strncmp(temponode->c,"---",3))&&((!*(3+temponode->c))||(*(3+temponode->c)==' ')))
      {
       temponode->a=MsgTearline;
       if(temponode->prev&&!strncmp(temponode->prev->c,"...",3)) temponode->prev->a=MsgTagline;
      }
 temponode->next=new ScrollNode;
 temponode->next->num=temponode->num+1;
 temponode->next->prev=temponode;
 temponode=temponode->next;
 temponode->c=new char[cMaxX+1];
 temponode->next=0;
 if(diver)
 {
  temponode->a=temponode->prev->a;
  _cache_string(text+_pos+1);
 }
 else
  temponode->a=MsgNormal; 
}

#define MAX_LINE_SIZE 16384

Viewer::Viewer() {_swapper=new char[MAX_LINE_SIZE];}

Viewer::~Viewer() {delete[] _swapper;}
