//
// Neslie
// Copyright (c) 1996-9 Alex Ermolovich
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __VIEWER_H
#define __VIEWER_H

#include "ftnpkt.h"

#define ACTION_QUIT   0
#define ACTION_NEXT   1
#define ACTION_PREV   2
#define ACTION_LAST   3
#define ACTION_FIRST  4
#define ACTION_DELETE 5
#define ACTION_BROWSE 6

#define BA_LOAD 1
#define BA_PREV 2
#define BA_NEXT 3
#define BA_PGUP 4
#define BA_PGDN 5
#define BA_HOME 6
#define BA_END  7
#define BA_QUIT 8
#define BA_KILL 9

#define NO_NEXT 1
#define NO_PREV 2

struct ScrollNode
{
 char*c;
 short int num,a;
 struct ScrollNode*prev,*next;
};

class Viewer
{
 char _act,_was_changed,_colors[24],_tempo_str[255],*_swapper;
 ScrollNode*temponode;
 char ShowMsg(FTNMessage*,char);
 void DrawHdr(void);
 void DoBrowse(FTNPacket*);
 void _cache_string(char*);
public:
 Viewer();
 ~Viewer();
 void ViewMsg(char*);
 char ViewPkt(char*);
};

#endif
